# -*- coding: utf-8 -*-

from . import wh_setting, api_list

#WH2API - version.md

# 16. 버전 정보 조회
def read(version_idx):
    api = api_list.version_read %(version_idx)
    result = wh_setting.get_requests(api=api)
    return result

# 1. 버전 설정 생성
def key(task_idx, which='shot or asset'):
    api = api_list.version_key %(which,task_idx)
    result = wh_setting.post_requests(api=api)
    return result['version_key']

# 2. 버전 설정 조회
def key_read(version_key):
    api = api_list.version_key_read
    data = {'version_key':version_key}
    result = wh_setting.post_requests(api=api,data=data)
    return result

# 5. 버전 생성
def create(task_idx='',
           which='shot or asset',
           version_name='',
           task_status_idx='',
           version_status_idx='',
           reviewer_user_idx='',
           hour_spent='',
           version_path=[],
           metadata= [],
           description="",
           cc_user_idx='',
           thumbnail_path = ""):


    #기본값 세팅
    version_key = key(task_idx,which)
    key_data = key_read(version_key)

    #api 세팅
    api = api_list.version_create %(which)

    #파일 유효성 검사
    version_path_check = wh_setting.file_folder_check(version_path)
    if version_path_check == None or version_path_check['file'] == []:
        print("업로드할 파일이 없습니다.")
        return 'error'

    else:
        data = {"which":which,
                "description": description,
                "version_key":version_key,
                "project_idx":key_data['project_idx'],
                "version_name":version_name,
                "task_status_idx":task_status_idx,
                "version_status_idx":version_status_idx,
                "hour_spent":hour_spent,
                "reviewer_user_idx":reviewer_user_idx,
                "main_path":version_path_check['file'][0],
                "attached_path[]":version_path_check['file'],
                "cc_user_idx[]":cc_user_idx,
                "metadata[]":metadata,
                }

        if which =="shot" :
            shot_data={"episode_idx": key_data['episode_idx'],
                       "sequence_idx": key_data['sequence_idx'],
                       "shot_idx": key_data['shot_idx']}
            data.update(shot_data)

        elif which =="asset":
            asset_data={"asset_category_idx": key_data['asset_category_idx'],
                        "asset_idx": key_data['asset_idx']}
            data.update(asset_data)
        else:
            print("which error")


    #file 데이터 정리

        files = {'attached[]':[]}
        for version in version_path_check['file']:
            # version_file = ('attached[]',open(version,'rb'))
            files['attached[]'].append(version)

        if thumbnail_path != "":

            # thumbnail_open = open(thumbnail_path, 'rb')
            # thumbnail_data = ("thumbnail",thumbnail_open)
            thumbnail_data = {"thumbnail":thumbnail_path}
            files.update(thumbnail_data)

        # print(version_path_check['file'][0],version_path_check['file'],files)
        result = wh_setting.post_requests(api=api, data=data,files=files)
        return result

# 7. 패스트 버전 설정 생성
def bulk_key(project_idx,episode_idx,kind='shot'or'asset'):
    api = api_list.version_bulk_key %(project_idx)
    data = {"episode_idx":episode_idx,"kind":kind}
    result = wh_setting.post_requests(api=api,data=data)
    return result

# 8 패스트 버전 설정 조회
def bulk_key_read(version_key):
    api = api_list.version_bulk_key_read
    data = {'version_key':version_key}
    result = wh_setting.post_requests(api=api,data=data)
    return result

# 9. 패스트 버전 데이터 검사
def bulk_validate(version_key,kind='shot'or'asset', project_idx="" ,episode_idx="" ,sequence_name=[],shot_name=[],
                  category_name=[],asset_name=[],task_name=[]):

    api = api_list.version_bulk_validate
    if kind =='shot':
        if project_idx and episode_idx and sequence_name and shot_name  and task_name !="":

            data = {'version_key':version_key,
                    'project_idx':project_idx,
                    'episode_idx':episode_idx,
                    'sequence_name[]':sequence_name,
                    'shot_name[]':shot_name,
                    'task_name[]':task_name,
                    'kind':kind}
        else:
            print('데이터가 부족합니다.')
    elif kind =='asset':
        if project_idx  and category_name and asset_name  and task_name !="":
            data = {'version_key':version_key,
                    'project_idx': project_idx,
                    'category_name[]': category_name,
                    'asset_name[]': asset_name,
                    'task_name[]': task_name,
                    'kind':kind}
        else:
            print('데이터가 부족합니다.')

    result = wh_setting.post_requests(api=api,data=data)
    return result

# 10. 버전 벌크 생성
def bulk_create(which,task_status_idx,version_status_idx,hour_spent,reviewer_user_idx,
                project_idx,
                episode_idx,sequence_name=[],shot_name=[],
                asset_category_name=[],asset_name=[],
                task_name=[],version_name=[],description=[],
                attached=[],attached_path=[],metadata=[],thumbnail=[]):


    #기본값 세팅
    api = api_list.version_bulk_create %(which)
    version_key = bulk_key(project_idx=project_idx,episode_idx=episode_idx,kind=which)['version_key']
    key_data = bulk_key_read(version_key)

    if which == 'shot':
        if project_idx and episode_idx and sequence_name and shot_name and task_name != "":

            data = {'version_key': version_key,
                    'project_idx': project_idx,
                    'episode_idx': episode_idx,
                    'sequence_name[]': sequence_name,
                    'shot_name[]': shot_name,
                    'task_name[]': task_name}
        else:
            print('데이터가 부족합니다.')
    elif which == 'asset':
        if project_idx and asset_category_name and asset_name and task_name != "":
            data = {'version_key': version_key,
                    'project_idx': project_idx,
                    'asset_category_name[]': asset_category_name,
                    'asset_name[]': asset_name,
                    'task_name[]': task_name}
        else:
            print('데이터가 부족합니다.')


    data_add = {'task_status_idx':task_status_idx,
                'version_status_idx':version_status_idx,
                'hour_spent':hour_spent,
                'reviewer_user_idx':reviewer_user_idx,
                'version_name[]':version_name,
                'description[]':description,
                'attached_path[]':attached_path,
                "metadata[]":metadata}

    data.update(data_add)

    files= {'attached[]':attached,'thumbnail[]':thumbnail}


    #필수값이 아닌 데이터 제거
    if data['description[]'] ==[] :
        del(data['description[]'])
    if data['metadata[]'] == []:
        del(data['metadata[]'])
    if files['thumbnail[]'] ==[]:
        del(files['thumbnail[]'])


    result = wh_setting.post_requests(api=api,data=data,files=files)
    return result, key_data